#include <qpushbt.h>
#include <qlcdnum.h>
#include <qlabel.h>
#include <qdialog.h>
#include <qapp.h>
#include <qtimer.h>
#include <qbitmap.h>
#include <qcombo.h>
#include <qmsgbox.h>
#include <qscrbar.h>
#include <qmenubar.h>
#include <qgrpbox.h>
#include <qtooltip.h>
#include <qkeycode.h>
#include <qaccel.h>
#include <qpopmenu.h>
#include <qpixmap.h>
#include <qfiledlg.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/utsname.h>
#include <unistd.h>
#if defined(_FreeBSD__) || defined(__NetBSD__)
#else
#include <mntent.h>
#include <sys/soundcard.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/resource.h>

#include "lib/player.h"

#include <kapp.h>
#include <kmsgbox.h>
#include <drag.h>
#include <kurl.h>

#include "kslider.h"
#include "playlist.h"
#include "ledpanel.h"

class KMaplay : public QWidget 
{
      Q_OBJECT
   private:
      LedPanel *ledPanel;
      QPushButton	*playPB;	// Play button
      QPushButton     *pausePB;       // Pause button
      QPushButton	*stopPB;	// Stop button
      QPushButton	*prevPB;	// Previous track
      QPushButton	*nextPB;	// Next track
      QPushButton	*fwdPB;		// "Fast" forward
      QPushButton	*bwdPB;		// "Fast" rewind
      
      QTimer		*timer;		// Timer to update the time
      
      KSlider         *slider;
      QMenuBar        *menu;

      Playlist        *playlist;
      Preferences     *prefsdialog;
      QFileDialog     *filedialog;
      
      QPixmap         pause_off, pause_on, play_off, play_on, stop_off, stop_on, prevPM, nextPM, prev_disPM, next_disPM;
      
      KDNDDropZone    *dropZone;
      
      QPushButton     *makeButton( int, int, int, int, const char * );
      void            updateButtons();
      void		drawPanel();
      void		loadBitmaps();
  
      enum PlayStatus { Nofile, Stopped, Playing, Paused, Seeking };
      PlayStatus status;
      int current_frame, current_sec, total_sec, ffrw_frames;
      
      streaminfo sinfo;
//      LinuxObuffer *buffer;
      Player *player;
      
   public:
      KMaplay( QWidget *parent = 0, const char *name = 0 );
      ~KMaplay();

   protected:
      void closeEvent ( QCloseEvent *);

   public slots:
      void            openFile(const char* );
      void            openClicked();
      void		playClicked();
      void            pauseClicked();
      void		stopClicked();
      void		prevClicked();
      void		nextClicked();
      void		fwdClicked();
      void		bwdClicked();
      void		quitClicked();
      void		aboutClicked();
      void            onTimer();
      void            newPos(int);
      void            onDrop( KDNDDropZone* );
      void slotHelp();
};
