#ifndef LEDPANEL_H
#define LEDPANEL_H

#include "lib/player.h"
#include <qwidget.h>
#include <qpixmap.h>
#include <qtimer.h>

class LedPanel : public QWidget
{
      Q_OBJECT
   private:
      int value_digits[5];
      QPixmap *pm_digits[10];
      QPixmap *pm_blank, *pm_pause, *pm_play, *pm_panel;
      QPixmap pm_back;
      QPixmap pm_filename;
      int scrollPos, scrollInc;
      QTimer *scrollTimer;

      void loadPixmaps();
      void updateDigit( int, int );
      void paintEvent( QPaintEvent* );
      void styleChange( GUIStyle );

   public:
      LedPanel( QWidget *parent = 0, const char *name = 0 );
      ~LedPanel();
      
   public slots:
      void play();
      void pause();
      void stop();
      void setTime( int );
      void setInfo( streaminfo* );
      void scrollTimeout();
};


#endif
