extern "C"
{
#include "mpg123.h"
}

#include "player.h"
#include <iostream.h>
#include <stdio.h>

Player::Player()
{
   MPEGinit();

   status = Nofile;
}

Player::~Player()
{
}

int Player::openFile(const char *_filename, streaminfo *_sinfo )
{
   FILE *fp;
      if ((fp=fopen(_filename,"r"))==NULL) return PLAYER_NOFILE;
   fclose(fp);
   MPEGplayfile( _filename );
   MPEGfillsinfo( _sinfo );
   (_sinfo->name = (char*)strrchr(_filename, '/')) ? _sinfo->name++ : (_sinfo->name = (char*)_filename);

//    _sinfo->ms_per_frame = (1152000>>(1-header->ID))/t_sampling_frequency[header->ID][header->sampling_frequency];
   _sinfo->ms_per_frame = 26; /* calculate this ????????? */
   _sinfo->min_number_of_frames = MPEGgetnumberofframes();

   status = Stopped;

   return PLAYER_OK;
}  

int Player::closeFile()
{
   if( status == Nofile )
      return PLAYER_NOFILE;
   MPEGclose();
   status = Nofile;
   return PLAYER_OK;
}

int Player::play()
{
  if(status==Nofile)
    return PLAYER_NOFILE;

  status=Playing;
  return PLAYER_OK;
}

int Player::pause()
{
  if(status==Nofile)
    return 0;

  return PLAYER_OK;
}

int Player::seek(int _frame)
{
   MPEGseek(_frame);
   return PLAYER_OK;
}

int Player::stop()
{
  if (status==Nofile)
    return 0;
  MPEGseek(0);
  status=Stopped;
  return 1;
}

int Player::loop()
{
  if( status==Seeking ) {
     return -1; // fail
  }
  
  if( status!=Playing )
     return -1; // fail
  
  // cerr << current_frame << endl;
  current_frame = MPEGloop();
  
  if (current_frame < 1) {
     return -1;
  }
  
  return current_frame; // success, should return frame number
}

void Player::setPreferences( prefsinfo *_prefs )
{
   MPEGsetpreferences( _prefs );
}

