#ifndef PLAYER_H
#define PLAYER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <iostream.h>
#include <unistd.h>

#include "sinfo.h"

#define PLAYER_OK            1 << 0
#define PLAYER_DEVICEBUSY    1 << 1
#define PLAYER_DEVICEINVALID 1 << 2
#define PLAYER_NOFILE        1 << 3
#define PLAYER_INVALIDFILE   1 << 4
#define PLAYER_UNSUPPORTED   1 << 5

class Player 
{
   public:
      enum Status { Stopped, Playing, Paused, Seeking, Nofile, DeviceBusy };
   private:
      Status status;
      int current_frame;
      
   public:
      Player( );
      ~Player();
      
      Status getStatus();
      
      int openFile(const char*, streaminfo*);
      int closeFile();
      
      int play();
      int pause();
      int seek(int);
      int stop();
      
      int loop();
      
      void setPreferences( prefsinfo* );
};

#endif

