#include <qdialog.h>
#include <qlistbox.h>
#include <qgrpbox.h>
#include <qfiledlg.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <signal.h>
#include <sys/utsname.h>
#include <unistd.h>
#if defined(_FreeBSD__) || defined(__NetBSD__)
#else
#include <mntent.h>
#include <sys/soundcard.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>

#include "lib/player.h"
#include <kapp.h>
#include <drag.h>
#include <kurl.h>
#include "prefs.h"


class Playlist : public QDialog {
  Q_OBJECT
private:
  QGroupBox *toolbar;
  QListBox *listbox;
  QWidget *buttonPanel;
  int lastselected;
  Preferences *prefs;

  virtual void resizeEvent( QResizeEvent* );

public:
  bool isEmpty();
  Playlist(Preferences *prefsdialog = 0, QWidget *parent = 0, const char *name = 0 );

signals:
  void fileSelected(const char*);

public slots:
  void selectPrev();
  void selectNext();
  void itemSelected(int);
  void addFile(const char*);
  void clear();
  void slotShow();
  void slotClose();
  void slotLoadPlaylist();
  void slotSavePlaylist();
  void slotAddPlaylist();
  void slotAddMPEG();
  void slotUp();
  void slotDown();
  void slotDelMPEG();
  void onDrop(KDNDDropZone*);
  void slotShuffle();
};
