
#include <string.h>
#include "prefs.h"

Preferences::Preferences( QWidget *parent, Player *_player ) :
   QDialog( parent )
{
   int tabwidth = 320, tabheight = 250, rbHeight;

//   KDNDDropZone *dropZone = new KDNDDropZone( this, DndURL );
//   connect( dropZone, SIGNAL( dropAction( KDNDDropZone* )),
//	    SLOT( onDrop( KDNDDropZone*)));


   player = _player;
   tabctl = new KTabCtl( this );
   
   page1 = new QWidget( tabctl );
   page2 = new QWidget( tabctl );
   page3 = new QWidget( tabctl );
   tabctl->addTab( page1, "General" );
   tabctl->addTab( page2, "MPEG Decoder" );
   tabctl->addTab( page3, "Audio Device" );

   // Define page 1
   QButtonGroup *grpbox1_1 = new QButtonGroup( "HTTP proxy", page1 );
   QLabel *lblServer = new QLabel( "Server", grpbox1_1 );
   lblServer->adjustSize();
   lblServer->move( 10, 20 );
   QLabel *lblPort = new QLabel( "Port", grpbox1_1 );
   lblPort->adjustSize();
   lblPort->move( tabwidth-65-lblServer->width() , 20 );   
   leHttpProxy = new QLineEdit( grpbox1_1 );
   leHttpProxy->move( 15+lblServer->width(), 18 );
   leHttpProxy->resize( lblPort->x()-leHttpProxy->x()-5, leHttpProxy->height()-8 );
   leHttpProxyPort = new QLineEdit( grpbox1_1 );
   leHttpProxyPort->move( lblPort->x()+lblPort->width()+5, 18 );
   leHttpProxyPort->resize( tabwidth - 35 - leHttpProxyPort->x(), leHttpProxyPort->height()-8);
   
   grpbox1_1->setGeometry( 10, 10, tabwidth-20, lblServer->height()+30 );

   cbPlayOnOpen = new QCheckBox( "Play files on open", page1 );
   cbPlayOnOpen->adjustSize();
   rbHeight = cbPlayOnOpen->height()+4;
   cbPlayOnOpen->move( 10, grpbox1_1->height() + 25 );
   cbReadID3 = new QCheckBox( "Read ID3 songname tag", page1 );
   cbReadID3->adjustSize();
   cbReadID3->move( 10, grpbox1_1->height() + 25 + rbHeight );
   cbAutoscroll = new QCheckBox( "Autoscroll songname", page1 );
   cbAutoscroll->adjustSize();
   cbAutoscroll->move( 10, grpbox1_1->height() + 25 + 2*rbHeight );
   cbEndless = new QCheckBox( "Repeat whole list", page1 );
   cbEndless->adjustSize();
   cbEndless->move( 10, grpbox1_1->height() + 25 + 3*rbHeight );

   // Define page 2
   QButtonGroup *grpbox1 = new QButtonGroup( "Decode in", page2 );
   rbStereo = new QRadioButton( "Stereo", grpbox1 );
   rbStereo->move( 10, 20 );
   rbStereo->adjustSize();
   rbMono = new QRadioButton( "Mono", grpbox1 );
   rbMono->adjustSize();
   rbMono->move( 10, 20 + rbHeight );
   rbMonoLeft = new QRadioButton( "Left ", grpbox1 );
   rbMonoLeft->adjustSize();
   rbMonoLeft->move( 25, 20 + rbHeight*2 );
   rbMonoRight = new QRadioButton( "Right ", grpbox1 );
   rbMonoRight->adjustSize();
   rbMonoRight->move( 25, 20 + rbHeight*3 );
   rbMonoMix = new QRadioButton( "Mix ", grpbox1 );
   rbMonoMix->adjustSize();
   rbMonoMix->move( 25, 20 + rbHeight*4 );
   grpbox1->setGeometry( 10, 10, tabwidth/2-15, 25+rbHeight*5 );
   buttonGroup = new QButtonGroup();
   buttonGroup->insert( rbMonoLeft, -2 );
   buttonGroup->insert( rbMonoRight, -2 );
   buttonGroup->insert( rbMonoMix, -2 );

   QButtonGroup *grpbox2 = new QButtonGroup( "Downsampling", page2 );
   rbDS1 = new QRadioButton( "None", grpbox2 );
   rbDS1->move( 10, 20 );
   rbDS1->adjustSize();
   rbDS2 = new QRadioButton( "1:2", grpbox2 );
   rbDS2->move( 10, 20 + rbHeight );
   rbDS2->adjustSize();
   rbDS3 = new QRadioButton( "1:4", grpbox2 );
   rbDS3->move( 10, 20 + 2*rbHeight );
   rbDS3->adjustSize();
   grpbox2->setGeometry( tabwidth/2+5, 10, tabwidth/2-15, grpbox1->height() );

   cbRangeViolation = new QCheckBox( "Check range violations", page2 );
   cbRangeViolation->adjustSize();
   cbRangeViolation->move( 10, grpbox2->height() + 25 );
   cbReSync = new QCheckBox( "Try to resync on error", page2 );
   cbReSync->adjustSize();
   cbReSync->move( 10, grpbox2->height() + 25 + rbHeight );
   cbScalefactor = new QCheckBox( "Change scalefactor", page2 );
   cbScalefactor->adjustSize();
   cbScalefactor->move( 10, grpbox2->height() + 25 + 2*rbHeight );
   leScalefactor = new QLineEdit( page2 );
   leScalefactor->adjustSize();
   leScalefactor->setGeometry( 25, grpbox2->height() + 25 + 3*rbHeight, tabwidth/2-45, leScalefactor->height()-8 );

   tabheight = leScalefactor->y() + leScalefactor->height() + 40;

   // Define page 3
   QButtonGroup *grpbox3_1 = new QButtonGroup( "Audio device", page3 );
   rbDeviceDefault = new QRadioButton( "Default ", grpbox3_1 );
   rbDeviceDefault->move( 10, 20 );
   rbDeviceDefault->adjustSize();
   rbDeviceOther = new QRadioButton( "Other ", grpbox3_1 );
   rbDeviceOther->adjustSize();
   rbDeviceOther->move( 10, 20 + rbHeight );
   leDevice = new QLineEdit( grpbox3_1 );
   leDevice->adjustSize();
   leDevice->setGeometry( 25, 20 + 2*rbHeight, tabwidth/2-45, leDevice->height()-8 );
   grpbox3_1->setGeometry( 10, 10, tabwidth/2-15, 25+rbHeight*2+leDevice->height() );

   QButtonGroup *grpbox3_2 = new QButtonGroup( "Output to", page3 );
   rbSpeaker = new QRadioButton( "Speaker ", grpbox3_2 );
   rbSpeaker->move( 10, 20 );
   rbSpeaker->adjustSize();
   rbLineout = new QRadioButton( "Line-out ", grpbox3_2 );
   rbLineout->move( 10, 20 + rbHeight );
   rbLineout->adjustSize();
   rbHeadphones = new QRadioButton( "Headphones ", grpbox3_2 );
   rbHeadphones->move( 10, 20 + 2*rbHeight );
   rbHeadphones->adjustSize();
   grpbox3_2->setGeometry( tabwidth/2+5, 10, tabwidth/2-15, grpbox3_1->height() );

   QButtonGroup *grpbox3 = new QButtonGroup( "Buffer", page3 );
   grpbox3->setGeometry( 10, 20+grpbox3_1->height(), tabwidth-20, 60 );
   slider = new KSlider( KSlider::Horizontal, grpbox3 );
   slider->setGeometry( 10, 20, grpbox3->width()-20, 20 );
   slider->setRange( 0, 16 );
   slider->setSteps( 1, 16 );
   QLabel *lbl2_a = new QLabel( "0 Kb", grpbox3 );
   lbl2_a->adjustSize();
   lbl2_a->move( 10, 40 );
   QLabel *lbl2_b = new QLabel( "256 Kb", grpbox3 );
   lbl2_b->adjustSize();
   lbl2_b->move( slider->width()-lbl2_b->width()+10, 40 );
   lbl2_b->setAlignment( AlignRight );

   cbForceTo8bit = new QCheckBox( "Use 8bit samples", page3 );
   cbForceTo8bit->adjustSize();
   cbForceTo8bit->move( 10, grpbox3->y()+grpbox3->height() + 15 );



   tabctl->setGeometry( 10, 10, tabwidth, tabheight );

   buttonOk = new QPushButton( "Ok", this );
   buttonOk->setGeometry( tabwidth-250, tabheight+20, 80, 25 );
   connect( buttonOk, SIGNAL(clicked()), this, SLOT(slotOk()));

   buttonApply = new QPushButton( "Apply", this );
   buttonApply->setGeometry( tabwidth-160, tabheight+20, 80, 25 );
   connect( buttonApply, SIGNAL(clicked()), this, SLOT(slotApply()));

   buttonCancel = new QPushButton( "Cancel", this );
   buttonCancel->setGeometry( tabwidth-70, tabheight+20, 80, 25 );
   connect( buttonCancel, SIGNAL(clicked()), this, SLOT(slotCancel()));

   QPushButton *pbHelp1 = new QPushButton( "Help", page1 );
   pbHelp1->setGeometry( tabwidth-94, tabheight-64, 80, 25 );
   connect( pbHelp1, SIGNAL(clicked()), this, SLOT(slotHelp1()));
   QPushButton *pbHelp2 = new QPushButton( "Help", page2 );
   pbHelp2->setGeometry( tabwidth-94, tabheight-64, 80, 25 );
   connect( pbHelp2, SIGNAL(clicked()), this, SLOT(slotHelp2()));
   QPushButton *pbHelp3 = new QPushButton( "Help", page3 );
   pbHelp3->setGeometry( tabwidth-94, tabheight-64, 80, 25 );
   connect( pbHelp3, SIGNAL(clicked()), this, SLOT(slotHelp3()));
   
   setFixedSize( tabwidth + 20, tabheight + 55 );
   setCaption( "Preferences" );

   // Notify when changes are made to any settings
   connect( leHttpProxy, SIGNAL(textChanged(const char*)), this, SLOT(slotChange(const char*)));
   connect( leHttpProxyPort, SIGNAL(textChanged(const char*)), this, SLOT(slotChange(const char*)));
   
   connect( cbPlayOnOpen, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( cbReadID3, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( cbAutoscroll, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( cbEndless, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbStereo, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbMono, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbMonoLeft, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbMonoRight, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbMonoMix, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbDS1, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbDS2, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbDS3, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( cbRangeViolation, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( cbReSync, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( cbScalefactor, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( leScalefactor, SIGNAL(returnPressed()), this, SLOT(slotChange()));
   connect( rbDeviceDefault, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbDeviceOther, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbSpeaker, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbLineout, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( rbHeadphones, SIGNAL(clicked()), this, SLOT(slotChange()));
   connect( leDevice, SIGNAL(textChanged(const char*)), this, SLOT(slotChange(const char*)));   
   connect( slider, SIGNAL(valueChanged(int)), this, SLOT(slotChange()));
   connect( cbForceTo8bit, SIGNAL(clicked()), this, SLOT(slotChange()));

   initPrefs();
   slotChange();
   applyPrefs();
}

void Preferences::initPrefs()
{
   KConfig* config = KApplication::getKApplication()->getConfig();
   QString string;
   int integer;

//   cerr << "Initializing prefs" << endl;
   
   config->setGroup( "General" );
   string = "server.domain.com";
   string = config->readEntry( "HTTPServer" );
   if( string.isNull() )
      string = "server.domain.com";
   leHttpProxy->setText( string );
   integer = config->readNumEntry( "HTTPPort", 8080 );
   string.setNum(integer);
   leHttpProxyPort->setText( string );
   integer = config->readNumEntry( "PlayOnOpen", 0 );
   cbPlayOnOpen->setChecked( integer );
   integer = config->readNumEntry( "ReadID3", 0 );
   cbReadID3->setChecked( integer );
   integer = config->readNumEntry( "Autoscroll", 1 );
   cbAutoscroll->setChecked( integer );
   integer = config->readNumEntry( "PlayEndless", 1 );
   cbEndless->setChecked( integer );
      
   config->setGroup("Decoder");
   integer = config->readNumEntry( "ForceToMono", 0 );
   rbMono->setChecked( integer );
   rbStereo->setChecked( !integer );
   integer = config->readNumEntry( "MonoMode", 3 );
   rbMonoLeft->setChecked( integer==1 );
   rbMonoRight->setChecked( integer==2 );
   rbMonoMix->setChecked( integer==3 );

   integer = config->readNumEntry( "Downsample", 1 );
   rbDS1->setChecked( integer==1 );
   rbDS2->setChecked( integer==2 );
   rbDS3->setChecked( integer==3 );

   integer = config->readNumEntry( "CheckRangeViolations", 0 );
   cbRangeViolation->setChecked( integer );

   integer = config->readNumEntry( "ReSync", 0 );
   cbReSync->setChecked( integer );

   integer = config->readNumEntry( "ChangeScalefactor", 0 );
   cbScalefactor->setChecked( integer );

   integer = config->readNumEntry( "Scalefactor", 32768 );
   string.setNum(integer);
   leScalefactor->setText( string );
   
   config->setGroup("AudioDevice");
   integer = config->readNumEntry( "AudioDeviceDefault", 1 );
   rbDeviceDefault->setChecked( integer );
   rbDeviceOther->setChecked( !integer );
   
   string = "/dev/dsp";
   string = config->readEntry( "AudioDevice" );
   if( string.isNull() )
      string = "/dev/dsp";
   leDevice->setText( string );
      
   integer = config->readNumEntry( "OutputTo", 1 );
   rbSpeaker->setChecked( integer==1 );
   rbLineout->setChecked( integer==2 );
   rbHeadphones->setChecked( integer==3 );
   
   integer = config->readNumEntry( "Buffer", 128 );
   slider->setValue(integer/16);
   integer = config->readNumEntry( "ForceTo8bit", 0 );
   cbForceTo8bit->setChecked(integer);

   prefsChanged = false;
   buttonApply->setEnabled( prefsChanged );   
}

void Preferences::applyPrefs()
{
   KConfig *config = KApplication::getKApplication()->getConfig();
   QString string;
   int integer;
   prefsinfo prefs;

   if (!prefsChanged)
      return;

//   cerr << "Applying prefs" << endl;

   config->setGroup("General");
   config->writeEntry( "HTTPServer", leHttpProxy->text() );
   prefs.http_proxy = strdup(leHttpProxy->text());   
   string = leHttpProxyPort->text();
   config->writeEntry( "HTTPPort", string.toInt() );
   prefs.http_proxy_port = string.toInt();
   config->writeEntry( "PlayOnOpen", cbPlayOnOpen->isChecked() );
   config->writeEntry( "ReadID3", cbReadID3->isChecked() );
   config->writeEntry( "Autoscroll", cbAutoscroll->isChecked() );
   config->writeEntry( "PlayEndless", cbEndless->isChecked() );

   config->setGroup("Decoder");
   config->writeEntry( "ForceToMono", rbMono->isChecked() );
   prefs.force_to_mono = rbMono->isChecked();
   integer = (rbMonoLeft->isChecked()?1:( rbMonoRight->isChecked()?2:3 ));
   config->writeEntry( "MonoMode", integer );
   prefs.mono_mode = integer;
   integer = (rbDS1->isChecked()?1:( rbDS2->isChecked()?2:3 ) );
   config->writeEntry( "Downsample", integer );
   prefs.downsample = integer;
   config->writeEntry( "CheckRangeViolations", cbRangeViolation->isChecked() );
   prefs.check_range_violations = cbRangeViolation->isChecked();
   config->writeEntry( "ReSync", cbReSync->isChecked() );
   prefs.resync = cbReSync->isChecked();
   config->writeEntry( "ChangeScalefactor", cbScalefactor->isChecked() );
   string = leScalefactor->text();
   config->writeEntry( "Scalefactor", string.toInt() );
   prefs.scalefactor = (cbScalefactor->isChecked())?string.toInt():0;
   
   config->setGroup("AudioDevice");
   config->writeEntry( "AudioDeviceDefault", rbDeviceDefault->isChecked() );
   config->writeEntry( "AudioDevice", leDevice->text() );
   prefs.device = (rbDeviceDefault->isChecked())?0:strdup(leDevice->text());
   strcpy( prefs.http_proxy, leHttpProxy->text() );

   config->writeEntry( "OutputTo", (rbSpeaker->isChecked()?1: (rbLineout->isChecked()?2:3 )) );
   prefs.output_to = (rbSpeaker->isChecked()?1: (rbLineout->isChecked()?2:3 ));
   config->writeEntry( "Buffer", slider->value()*16 );   
   prefs.buffersize = slider->value() * 16;
   config->writeEntry( "ForceTo8bit", cbForceTo8bit->isChecked() );

   config->sync();
   
   player->setPreferences( &prefs );   
   free( prefs.http_proxy );
   if( prefs.device )
      free( prefs.device );

   prefsChanged = false;
   buttonApply->setEnabled( prefsChanged );
}

void Preferences::slotShow()
{
   initPrefs();
   show();
}

void Preferences::slotOk()
{
//   cerr << "OK pressed, ";
   applyPrefs();
   hide();
}

void Preferences::slotApply()
{
//   cerr << "Apply pressed" << endl;
   applyPrefs();
}

void Preferences::slotCancel()
{
//   cerr << "Cancelling prefs dialog" << endl;
   hide();
}

void Preferences::slotChange()
{
//   if (prefsChanged)
//      return;
   
   prefsChanged = true;
   buttonApply->setEnabled( prefsChanged );
   rbMonoLeft->setEnabled( rbMono->isChecked() );
   rbMonoRight->setEnabled( rbMono->isChecked() );
   rbMonoMix->setEnabled( rbMono->isChecked() );
   leScalefactor->setEnabled( cbScalefactor->isChecked() );
   leDevice->setEnabled( rbDeviceOther->isChecked() );
}

void Preferences::slotChange( int )
{
   slotChange();
}

void Preferences::slotChange( const char* )
{
   slotChange();
}

void Preferences::slotHelp1()
{
   KApplication::getKApplication()->invokeHTMLHelp( 
      "kmpg/kmpg-5.html", "ss5.1" );
}

void Preferences::slotHelp2()
{
   KApplication::getKApplication()->invokeHTMLHelp( 
      "kmpg/kmpg-5.html", "ss5.2" );
}

void Preferences::slotHelp3()
{
   KApplication::getKApplication()->invokeHTMLHelp( 
      "kmpg/kmpg-5.html", "ss5.3" );
}

void Preferences::setPlayEndless( int integer )
{
	cbEndless->setChecked( integer );
}

int Preferences::getPlayEndless()
{
	if ( cbEndless->isChecked() ) {
//		cerr << "Prefs: endless is set" << endl;
		return 1;
	}
	else {
//		cerr << "Prefs: endless is NOT set" << endl;
		return 0;
	}
}
