#include <qdialog.h>
#include <qlabel.h>
#include <qpushbt.h>
#include <qbttngrp.h>
#include <qradiobt.h>
#include <qchkbox.h>
#include <qbttngrp.h> 
#include <qlined.h>
#include <ktabctl.h>
#include <kconfig.h>
#include <kapp.h>
#include "kslider.h"
#include "lib/player.h"

class Preferences : public QDialog
{
      Q_OBJECT
   private:
      QPushButton *buttonOk, *buttonApply, *buttonCancel;
      KTabCtl *tabctl;

      // pages
      QWidget *page1, *page2, *page3;

      // page 1
      QLineEdit *leHttpProxy, *leHttpProxyPort;
      QCheckBox *cbPlayOnOpen, *cbReadID3, *cbAutoscroll, *cbEndless;

      // page 2
      QRadioButton *rbMono, *rbMonoLeft, *rbMonoRight, *rbMonoMix, *rbStereo, *rbDS1, *rbDS2, *rbDS3;
      QButtonGroup *buttonGroup;
      QCheckBox *cbRangeViolation, *cbScalefactor, *cbReSync;
      QLineEdit *leScalefactor;
      
      // page 3
      QRadioButton *rbDeviceDefault, *rbDeviceOther, *rbSpeaker, *rbLineout, *rbHeadphones;
      QCheckBox *cbForceTo8bit;
      QLineEdit *leDevice;
      KSlider *slider;

      Player *player;

      int prefsChanged;

      void initPrefs();

   public:
      Preferences( QWidget *parent , Player *_player );
      void applyPrefs();
	  int getPlayEndless();
	  void setPlayEndless(int = 1);

   public slots:
      void slotShow();
      void slotOk();
      void slotApply();
      void slotCancel();
      void slotChange();  // Called whenever a setting is changed
      void slotChange(int); // Alternative, used by Kslider
      void slotChange( const char* );
      void slotHelp1();
      void slotHelp2();
      void slotHelp3();
};

